package com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.util;

import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.*;
import com.jeeplus.modules.sg.managementcenter.materialproject.util.ImportUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Row;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author: 王强
 * @create: 2022-08-16 15:01
 **/
public class ExcelImportUtil {

    /**
     * 获取储备项目概预算统计表表格数据
     *
     * @param importUtil
     * @return List<BudgetStats> 导入表格数据
     */
    public static List<Cable> getCableUtil(ImportUtil importUtil,List<String> proIdList) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<Cable> list = new ArrayList<Cable>();
        Cable cable = null;

        for(int i=3; i<=lastRow;i++) {
            cable = new Cable();
            Row row = importUtil.getRow(i);

//            String reserveProjectName = (String) importUtil.getCellValue(row, 1);
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 10);
            if (StringUtils.isNotBlank(projectReserveId)) {

                cable.setProjectReserveId((String) importUtil.getCellValue(row, 10));

                //和基本信息表比对，是否有对应的数据
                getBmList2(proIdList,cable.getProjectReserveId());

                cable.setCivilEngineer(null);
                cable.setCableTrenchBuild((String) importUtil.getCellValue(row, 30));
                cable.setPipeLayeCable((String) importUtil.getCellValue(row, 31));
                cable.setCompletePipe((String) importUtil.getCellValue(row, 32));
                cable.setCompleteMeasurement(null);
                cable.setMeasureLength(null);
                cable.setSegmentLengthClassinication((String) importUtil.getCellValue(row, 33));
                cable.setRemarks((String) importUtil.getCellValue(row, 34));

                list.add(cable);
            }
        }
        return list;
    }

    /**
     * 获取储备项目概预算统计表表格数据
     *
     * @param importUtil
     * @return List<BudgetStats> 导入表格数据
     */
    public static List<BudgetStats> getBudgetUtil(ImportUtil importUtil,List<String> proIdList) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<BudgetStats> list = new ArrayList<BudgetStats>();
        BudgetStats budgetStats = null;

        for(int i=2; i<=lastRow;i++) {
            budgetStats = new BudgetStats();
            Row row = importUtil.getRow(i);

//            String reserveProjectName = (String) importUtil.getCellValue(row, 1);
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 10);
            if (StringUtils.isNotBlank(projectReserveId)) {

                budgetStats.setProjectReserveId((String) importUtil.getCellValue(row, 10));
                //和基本信息表比对，是否有对应的数据
                getBmList2(proIdList,budgetStats.getProjectReserveId());

                budgetStats.setPretrialEstimateAmount((String) importUtil.getCellValue(row, 22));
                budgetStats.setPretrialEstimateAmountExcludeTax((String) importUtil.getCellValue(row, 23));
                budgetStats.setPretrialDeductibleAmount((String) importUtil.getCellValue(row, 24));
                budgetStats.setPretrialConstructeConsts((String) importUtil.getCellValue(row, 25));
                budgetStats.setPretrialMaterialAmount((String) importUtil.getCellValue(row, 26));
                budgetStats.setPretrialOtherExpanses((String) importUtil.getCellValue(row, 27));
                budgetStats.setPretrialPreliminaryConstructeFee((String) importUtil.getCellValue(row, 28));
                budgetStats.setPretrialSurveyFee((String) importUtil.getCellValue(row, 29));
                budgetStats.setPretrialDesignFee((String) importUtil.getCellValue(row, 30));
                budgetStats.setPretrialSupervisionFee((String) importUtil.getCellValue(row, 31));
                budgetStats.setAfterTrialEstimateAmount((String) importUtil.getCellValue(row, 32));
                budgetStats.setAfterTrialEstimateAmountExcludeTax((String) importUtil.getCellValue(row, 33));
                budgetStats.setAfterTrialDeductibleAmount((String) importUtil.getCellValue(row, 34));
                budgetStats.setAfterTrialConstructeConsts((String) importUtil.getCellValue(row, 35));
                budgetStats.setAfterTrialMaterialAmount((String) importUtil.getCellValue(row, 36));
                budgetStats.setAfterTrialOtherExpanses((String) importUtil.getCellValue(row, 37));
                budgetStats.setAfterTrialPreliminaryConstructeFee((String) importUtil.getCellValue(row, 38));
                budgetStats.setAfterTrialSurveyFee((String) importUtil.getCellValue(row, 39));
                budgetStats.setAfterTrialDesignFee((String) importUtil.getCellValue(row, 40));
                budgetStats.setAfterTrialSupervisionFee((String) importUtil.getCellValue(row, 41));

                list.add(budgetStats);
            }
        }
        return list;
    }

    /**
     * 获取储备项目特殊物资统计表表格数据
     *
     * @param importUtil
     * @return List<SpecialSupply> 导入表格数据
     */
    public static List<SpecialSupply> getSpecialUtil(ImportUtil importUtil,List<String> proIdList) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<SpecialSupply> list = new ArrayList<SpecialSupply>();
        SpecialSupply specialSupply = null;

        for(int i=2; i<=lastRow;i++) {
            specialSupply = new SpecialSupply();
            Row row = importUtil.getRow(i);

//            String reserveProjectName = (String) importUtil.getCellValue(row, 1);
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 10);
            if (StringUtils.isNotBlank(projectReserveId)) {

                specialSupply.setProjectReserveId((String) importUtil.getCellValue(row, 10));

                //和基本信息表比对，是否有对应的数据
                getBmList2(proIdList,specialSupply.getProjectReserveId());

                specialSupply.setNumberOfBranchBoxFourWay((String) importUtil.getCellValue(row, 32));
                specialSupply.setNumberOfBranchBoxFiveWay((String) importUtil.getCellValue(row, 33));
                specialSupply.setNumberOfBranchBoxSevenWay((String) importUtil.getCellValue(row, 34));
                specialSupply.setSpecialSizeA((String) importUtil.getCellValue(row, 36));
                specialSupply.setSpecialSizeB((String) importUtil.getCellValue(row, 37));
                specialSupply.setSpecialSizeC((String) importUtil.getCellValue(row, 38));
                specialSupply.setSpecialSizeD((String) importUtil.getCellValue(row, 39));

                list.add(specialSupply);
            }
        }
        return list;
    }

    /**
     * 获取储备进度统计表表格数据
     *
     * @param importUtil
     * @return List<BudgetStats> 导入表格数据
     */
    public static List<ProgressStats> getProgressUtil(ImportUtil importUtil,List<String> proIdList) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<ProgressStats> list = new ArrayList<ProgressStats>();
        ProgressStats progressStats = null;
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        for (int i = 3; i <= lastRow; i++) {
            progressStats = new ProgressStats();
            Row row = importUtil.getRow(i);

            String reserveProjectName = (String) importUtil.getCellValue(row, 1);
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 10);
            if (StringUtils.isNotBlank(reserveProjectName)) {
                if (StringUtils.isNotBlank(projectReserveId)) {
                    progressStats.setProjectReserveId((String) importUtil.getCellValue(row, 10));//项目储备编号

                    //和基本信息表比对，是否有对应的数据
                    getBmList2(proIdList,progressStats.getProjectReserveId());

                    progressStats.setInspectDepartmentReview((String) importUtil.getCellValue(row, 22));//是否通过运检部评审

                    if (StringUtils.isNotEmpty((String) importUtil.getCellValue(row, 23))){
                        try {
                            Date parse = format.parse((String) importUtil.getCellValue(row, 23));
                            progressStats.setInspectDepartmentReviewTime(format.format(parse));//通过运检部评审时间
                        }catch (Exception e){
                            progressStats.setInspectDepartmentReviewTime(null);//通过运检部评审时间
                        }
                    }else {
                        progressStats.setInspectDepartmentReviewTime(null);//通过运检部评审时间
                    }

                    if (StringUtils.isNotEmpty((String) importUtil.getCellValue(row, 24))){
                        try {
                            Date parse = format.parse((String) importUtil.getCellValue(row, 24));
                            progressStats.setReleaseReserveTime(format.format(parse));//运检部下达储备时间
                        }catch (Exception e){
                            progressStats.setReleaseReserveTime(null);//运检部下达储备时间
                        }
                    }else {
                        progressStats.setReleaseReserveTime(null);//运检部下达储备时间
                    }

                    if (StringUtils.isNotEmpty((String) importUtil.getCellValue(row, 27))){
                        try {
                            Date parse = format.parse((String) importUtil.getCellValue(row, 27));
                            progressStats.setLimitDate(format.format(parse));//初设提交限定日期
                        }catch (Exception e){
                            progressStats.setLimitDate(null);//初设提交限定日期
                        }
                    }else {
                        progressStats.setLimitDate(null);//初设提交限定日期
                    }

                    progressStats.setOnSiteConfess((String) importUtil.getCellValue(row, 28));//是否进行现场交底

                    if (StringUtils.isNotEmpty((String) importUtil.getCellValue(row, 29))){
                        try {
                            Date parse = format.parse((String) importUtil.getCellValue(row, 29));
                            progressStats.setConfessCompleteTime(format.format(parse));//交底完成时间
                        }catch (Exception e){
                            progressStats.setConfessCompleteTime(null);//交底完成时间
                        }
                    }else {
                        progressStats.setConfessCompleteTime(null);//交底完成时间
                    }

                    progressStats.setDrawRemarks((String) importUtil.getCellValue(row, 37));//项目经理审图-备注
                    progressStats.setBudgetRemarks((String) importUtil.getCellValue(row, 43));//概预算审核-备注
                    progressStats.setDrawingUnionRemarks((String) importUtil.getCellValue(row, 55));//图纸联合审查-备注
                    progressStats.setDrawingDate(null);//通知出图日期
//                    if (StringUtils.isNotEmpty((String) importUtil.getCellValue(row, 50))){
//                        try {
//                            Date parse = format.parse((String) importUtil.getCellValue(row, 50));
//                            progressStats.setDrawingDate(format.format(parse));//通知出图日期
//                        }catch (Exception e){
//                            progressStats.setDrawingDate(null);//通知出图日期
//                        }
//                    }else {
//                        progressStats.setDrawingDate(null);//通知出图日期
//                    }


                    list.add(progressStats);
                }
            }
        }
        return list;
    }

    /**
     * 获取储备项目建设规模统计表表格数据
     *
     * @param importUtil
     * @return List<BudgetStats> 导入表格数据
     */
    public static List<ConstructeScale> getConstructeUtil(ImportUtil importUtil,List<String> proIdList) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<ConstructeScale> list = new ArrayList<ConstructeScale>();
        ConstructeScale constructeScale = null;

        for (int i = 3; i <= lastRow; i++) {
            constructeScale = new ConstructeScale();
            Row row = importUtil.getRow(i);

            String reserveProjectName = (String) importUtil.getCellValue(row, 7);
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 6);
            if (StringUtils.isNotBlank(reserveProjectName)) {
                if (StringUtils.isNotBlank(projectReserveId)) {
                    constructeScale.setProjectReserveId((String) importUtil.getCellValue(row, 6));//项目储备编号

                    //和基本信息表比对，是否有对应的数据
                    getBmList2(proIdList,constructeScale.getProjectReserveId());

                    constructeScale.setConstructePurpose((String) importUtil.getCellValue(row, 9));//建设目的
                    constructeScale.setFactoryPrefab((String) importUtil.getCellValue(row, 31));//土建工厂化预制
                    constructeScale.setAncillaryFacility((String) importUtil.getCellValue(row, 32));//附属设施
                    constructeScale.setConstructionWorkMethod((String) importUtil.getCellValue(row, 33));//施工作业方式
                    constructeScale.setWorkWithoutInterruption((String) importUtil.getCellValue(row, 34));//不停电作业
                    String number = (String)importUtil.getCellValue(row, 35) == ""? "0" : (String)importUtil.getCellValue(row, 35);
                    int num = Integer.parseInt(number);
                    constructeScale.setPowerFailureHouseNum(num);//停电时户数
                    constructeScale.setPeakSummerProject((String) importUtil.getCellValue(row, 37));//是否迎峰度夏项目
                    constructeScale.setProjectReview((String) importUtil.getCellValue(row, 38));//通过第几批项目评审

                    list.add(constructeScale);
                }
            }
        }
        return list;
    }

    public static String dateFormat(String time) throws ParseException {
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm");
        Date parse = format.parse(time);
        String format1 = format.format(parse);
        return format1;
    }

    public static void getBmList2(List<String> sjkList, String proId) throws Exception {
        if (!sjkList.contains(proId)){
            throw new Exception("项目储备编号为" + proId + "等项目在基础信息表中不存在相关数据！");
        }
    }
}
